%define ocamlname base

Name:           ocaml-%{ocamlname}
Version:        0.10.0
Release:        1%{?dist}.emp1
Summary:        Full standard library replacement for OCaml
License:        Apache-2.0
URL:            https://github.com/janestreet/base
Source0:        %{ocamlname}-v%{version}.tar.gz

Requires:       ocaml >= 4.04.1
Requires:       ocaml < 4.07.0
Requires:       ocaml-sexplib >= 0.10
Requires:       ocaml-sexplib < 0.11

BuildRequires:  opam-installer >= 2.0
BuildRequires:  jbuilder
BuildRequires:  ocaml >= 4.04.1
BuildRequires:  ocaml < 4.07.0
BuildRequires:  ocaml-sexplib-devel >= 0.10
BuildRequires:  ocaml-sexplib-devel < 0.11

%description
Base is a standard library for OCaml. It provides a standard set of
general purpose modules that are well-tested, performant, and
fully-portable across any environment that can run OCaml code. Unlike
other standard library projects, Base is meant to be used as a
wholesale replacement of the standard library distributed with the
OCaml compiler. In particular it makes different choices and doesn’t
re-export features that are not fully portable such as I/O, which are
left to other libraries.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-sexplib-devel >= 0.10
Requires:       ocaml-sexplib-devel < 0.11

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-v%{version}

%build
jbuilder build  -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
echo %{ocamlname} > \
    %{buildroot}/%{_libdir}/ocaml/stublibs/dll%{ocamlname}_stubs.so.owner

%files
%doc %{_libdir}/ocaml/doc/base/LICENSE.txt
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner

%files devel
%doc %{_libdir}/ocaml/doc/base/README.org
%doc ROADMAP.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
